'use strict';

const find = require('find');
const replace = require('replace-in-file');

// add ".js" after all import/export statements
const files = find.fileSync(/.\.js/i, "build");

for (const file of files) {
    const options = {
        files: file,
        from: /((import|export) .* from .*)\";/g,
        to: "$1.js\";"
    };
    replace.sync(options);
}

// replace base-64 (could not make it work) with btoa
const r1 = {
    files: "build/src/jalhyd_object.js",
    from: /import \* as base64.*/g,
    to: ""
};
const r2 = {
    files: "build/src/jalhyd_object.js",
    from: /base64\.encode*/g,
    to: "btoa"
};
replace.sync(r1);
replace.sync(r2);
